package tools 
{
	import biga.CrossHair;
	import biga.Edge;
	import biga.GeomUtils;
	import biga.Intersection;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class EdgesSample extends Sprite 
	{
		private var c0:CrossHair;
		private var c1:CrossHair;
		private var c2:CrossHair;
		private var c3:CrossHair;
		private var edge0:Edge;
		private var edge1:Edge;
		
		public function EdgesSample() 
		{
			
			c0 = new CrossHair( 0, 12 );
			addChild( c0 );
			c1 = new CrossHair( 0, 12 );
			addChild( c1 );
			
			c0.x = 50;
			c1.x = 450;
			c0.y = c1.y = 250;
			edge0 = new Edge( c0.point, c1.point );
			
			
			
			c2 = new CrossHair( 0, 12 );
			addChild( c2 );
			c3 = new CrossHair( 0, 12 );
			addChild( c3 );
			
			c2.x = 200;
			c3.x = 300;
			c2.y = 150;
			c3.y = 350;
			edge1 = new Edge( c2.point, c3.point );
			
			addEventListener( Event.ENTER_FRAME, update );
			
		}
		
		private function update(e:Event):void 
		{
			
			graphics.clear();
			edge0.p0 = c0.point;
			edge0.p1 = c1.point;
			
			edge1.p0 = c2.point;
			edge1.p1 = c3.point;
			
			graphics.lineStyle( 4, 0xFFCC00 );
			edge0.draw( graphics );
			
			graphics.lineStyle( 4, 0x003366 );
			edge1.draw( graphics );
			
			var ip0:Point;
			var ip1:Point;
			
			ip0 = GeomUtils.constrain( c2.point, edge0.p0, edge0.p1 );
			ip1 = GeomUtils.constrain( c3.point, edge0.p0, edge0.p1 );
			
			graphics.lineStyle( 0, 0, 0 );
			
			graphics.beginFill( 0x00CC00, .2 );
			
			graphics.moveTo( c2.x, c2.y );
			graphics.lineTo( ip0.x, ip0.y );
			graphics.lineTo( ip1.x, ip1.y );
			graphics.lineTo( c3.x, c3.y );
			
			graphics.endFill();
			
			graphics.lineStyle( 4, 0x00CC00 );
			graphics.moveTo( ip0.x, ip0.y );
			graphics.lineTo( ip1.x, ip1.y );
			
			
			ip0 = Intersection.lineIntersectLine( edge0.p0, edge0.p1, edge1.p0, edge1.p1, false, false );
			if ( ip0 != null )
			{
				
				graphics.lineStyle( 2, 0xDD0000 );
				graphics.drawCircle( ip0.x, ip0.y, 10 );
				graphics.endFill();
				
			}
			
			ip0 = Intersection.lineIntersectLine( edge0.p0, edge0.p1, edge1.p0, edge1.p1 );
			if ( ip0 != null )
			{
				
				graphics.lineStyle( 0, 0, 0 );
				graphics.beginFill( 0xDD0000 );
				graphics.drawRect( ip0.x - 5, ip0.y - 5, 10, 10 );
				graphics.endFill();
				
			}
			
			
			
		}
		
	}

}