package tools 
{
	import biga.CrossHair;
	import biga.GeomUtils;
	import biga.Line;
	import com.bit101.components.HUISlider;
	import com.bit101.components.Label;
	import flash.display.Sprite;
	import flash.events.Event;
	/**
	 * @author Nicolas Barradeau
	 * http://en.nicoptere.net
	 */
	public class LineSample extends Sprite
	{
		private var c0:CrossHair;
		private var c1:CrossHair;
		private var c2:CrossHair;
		private var line:Line;
		private var sliderStart:HUISlider;
		private var sliderEnd:HUISlider;
		private var sliderPointAt:HUISlider;
		private var slopeLabel:Label;
		
		public function LineSample() 
		{
			
			c0 = new CrossHair( 0x0000FF, 12 );
			addChild( c0 );
			c1 = new CrossHair( 0xFF0000, 12 );
			addChild( c1 );
			
			c2 = new CrossHair( 0, 12 );
			c2.fixed = true;
			addChild( c2 );
			
			c0.x = 50;
			c1.x = 450;
			c0.y = c1.y = 250;
			
			var oy:int = -10;
			sliderStart = new HUISlider( this, 10, oy += 20, "line start 0 - 1" );
			sliderEnd = new HUISlider( this, 10, oy += 20, "line start -1 - 0" );
			
			sliderEnd.minimum = -100;
			sliderEnd.maximum = 0;
			
			sliderPointAt = new HUISlider( this, 10, oy += 20, "get point at" );
			sliderPointAt.minimum = -200;
			sliderPointAt.maximum = 200;
			sliderPointAt.value = 50;
			
			slopeLabel = new Label( this, 10, oy += 20, 'slope' );
			
			line = new Line( c0.point, c1.point );
			
			addEventListener( Event.ENTER_FRAME, update );
			
		}
		
		private function update(e:Event):void 
		{
			
			graphics.clear();
			line.p0 = c0.point;
			line.p1 = c1.point;
			
			line.start = -10;
			line.end = 10;
			graphics.lineStyle( 2, 0x003366 );
			line.draw( graphics );
			
			line.start = sliderStart.value * 0.01;
			line.end = sliderEnd.value * 0.01;
			
			graphics.lineStyle( 4, 0xFFCC00 );
			line.draw( graphics );
			
			c2.point = line.getPointAt( sliderPointAt.value * .01 );
			
			
			var slope:Number = GeomUtils.slope( line.p0, line.p1 );
			slopeLabel.text = ( slope == 0 ) ? 'horizontal' : ( slope < 0 ) ? 'ascending' : 'descending'; 
			
			
		}
		
	}

}